stages:
  - build
  - test
  - deploy

build_site:
  image:
    # Copied from https://github.com/google/docsy-example/blob/2bc1142e4466392ae2f5f58b0d3a8be13ca42482/Dockerfile
    name: floryn90/hugo:0.124.1-ext-alpine-ci
  stage: build
  script:
    - hugo
  artifacts:
    paths:
      - public # generating site folder to be browsed or download
  variables:
    HUGO_ENV: production

html5validator:
  image: cyb3rjak3/html5validator
  stage: test
  script:
    - tests/html_validate_test

hyperlinkcheck:
  image:
    name: ghcr.io/untitaker/hyperlink:0.1.32
    # Not totally sure why, but the default entrypoint of "hyperlink" gives errors like
    # "error: Found argument '-c' which wasn't expected, or isn't valid in this context"
    # Instead, unset the entrypoint, and call hyperlink ourselves below.
    entrypoint: [""]
  stage: test
  script: "hyperlink --sources content/en --check-anchors public/"

# 'pages' is a specially-named job that will deploy and build your site to the
# 'public' path to GitLab Pages.
pages:
  image:
    # Copied from https://github.com/google/docsy-example/blob/2bc1142e4466392ae2f5f58b0d3a8be13ca42482/Dockerfile
    name: floryn90/hugo:0.124.1-ext-alpine-ci
  stage: deploy
  script:
    # https://github.com/klakegg/docker-hugo/issues/41#issuecomment-805607666
    - apk add --update brotli
    - hugo
    # https://docs.gitlab.com/ee/user/project/pages/introduction.html#serving-compressed-assets
    - find public -type f -regex '.*\.\(htm\|html\|txt\|text\|js\|css\|json\)$' -exec gzip --best -f -k {} \;
    - find public -type f -regex '.*\.\(htm\|html\|txt\|text\|js\|css\|json\)$' -exec brotli -f -k {} \;
  # Ensure no two pipelines are deploying to prod in parallel.
  # https://docs.gitlab.com/ee/ci/yaml/#resource_group
  resource_group: production
  artifacts:
    paths:
      - public
  only:
    - main # this job will affect only the 'main' branch
  variables:
    HUGO_ENV: production

